---
title: Conditional (ternary) operator
slug: Web/JavaScript/Reference/Operators/Conditional_Operator
tags:
  - Conditional
  - Decision
  - JS
  - JavaScript
  - Language feature
  - Operator
  - Reference
  - else
  - if
  - ternary
---
<div>{{jsSidebar("Operators")}}</div>

<p><span class="seoSummary">The <strong>conditional (ternary) operator</strong> is the only JavaScript operator that takes three operands: a condition followed by a question mark (<code>?</code>), then an expression to execute if the condition is {{Glossary("truthy")}} followed by a colon (<code>:</code>), and finally the expression to execute if the condition is {{Glossary("falsy")}}.</span> This operator is frequently used as a shortcut for the <a href="/en-US/docs/Web/JavaScript/Reference/Statements/if...else"><code>if</code></a> statement.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-conditionaloperators.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>condition</var> ? <var>exprIfTrue</var> : <var>exprIfFalse</var></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>condition</var></code></dt>
 <dd>An expression whose value is used as a condition.</dd>
 <dt><code><var>exprIfTrue</var></code></dt>
 <dd>An expression which is evaluated if the <code><var>condition</var></code> evaluates to a {{Glossary("truthy")}} value (one which equals or can be converted to <code>true</code>).</dd>
 <dt><code><var>exprIfFalse</var></code></dt>
 <dd>An expression which is executed if the <code><var>condition</var></code> is {{Glossary("falsy")}} (that is, has a value which can be converted to <code>false</code>).</dd>
</dl>

<h2 id="Description">Description</h2>

<p>Besides <code>false</code>, possible falsy expressions are: <code>null</code>, <code>NaN</code>, <code>0</code>, the empty string (<code>""</code>), and <code>undefined</code>. If <code><var>condition</var></code> is any of these, the result of the conditional expression will be the result of executing the expression <code>exprIfFalse</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_example">A simple example</h3>

<pre class="brush: js notranslate">var age = 26;
var beverage = (age &gt;= 21) ? "Beer" : "Juice";
console.log(beverage); // "Beer"
</pre>

<h3 id="Handling_null_values">Handling null values</h3>

<p>One common usage is to handle a value that may be <code>null</code>:</p>

<pre class="brush: js notranslate">let greeting = person =&gt; {
    let name = person ? person.name : `stranger`
    return `Howdy, ${name}`
}

console.log(greeting({name: `Alice`}));  // "Howdy, Alice"
console.log(greeting(null));             // "Howdy, stranger"
</pre>

<h3 id="Conditional_chains">Conditional chains</h3>

<p>The ternary operator is right-associative, which means it can be "chained" in the following way, similar to an <code>if … else if … else if … else</code> chain:</p>

<pre class="brush: js notranslate">function example(…) {
    return condition1 ? value1
         : condition2 ? value2
         : condition3 ? value3
         : value4;
}

// Equivalent to:

function example(…) {
    if (condition1) { return value1; }
    else if (condition2) { return value2; }
    else if (condition3) { return value3; }
    else { return value4; }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-conditional-operator', 'Conditional Operator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("javascript.operators.conditional")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/if...else">if statement</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Nullish_coalescing_operator">Nullish coalescing operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Optional_chaining">Optional chaining</a></li>
 <li><a href="/en-US/docs/Learn/JavaScript/Building_blocks/conditionals">Making decisions in your code — conditionals</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators">Expressions and operators</a></li>
</ul>
